
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java执行效率低，但效率就低吗？ / 憋错料</title>

    <meta name="description" content="java执行效率低，但效率就低吗？ 很多没用过java或者没怎么用过java的程序员都会说java执行效率低,这种言论时不时的在影响着我这个初级的java开发者. java执行效率低因如下几点导致(和C++比较): 1,java不允许内存地址类型被修改,也不能像C++那样直接给内存地址加偏移量直接操作内存.C++处理内存地址办法确实直接了当,执行效率很高,但是也容易出现bug,java使用对象时,严格遵循类型转换规则. 2,C++在new对象之后有delete操作符来及时释放内存.java有垃圾回收机制,一段时间后会自动回收不再被">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">java执行效率低，但效率就低吗？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>很多没用过java或者没怎么用过java的程序员都会说java执行效率低，这种言论时不时的在影响着我这个初级的java开发者。</p>
<p>java执行效率低因如下几点导致（和C++比较）：</p>
<p>1，java不允许内存地址类型被修改，也不能像C++那样直接给内存地址加偏移量直接操作内存。C++处理内存地址办法确实直接了当，执行效率很高，但是也容易出现bug，java使用对象时，严格遵循类型转换规则。</p>
<p>2，C++在new对象之后有delete操作符来及时释放内存。java有垃圾回收机制，一段时间后会自动回收不再被需要的对象。这个时差也是效率的体现。</p>
<p>3，一个指定为有10个成员的数组，写入第十一个成员时C++不会限制这种灵活操作上的错误。程序员没限制，直接操作内存。</p>
<p>综上所述：java的效率低，因为限制多，带来的好处是错误相对较少。没有规矩，不成方圆，我认为循规蹈矩地开发才是java的思想吧，java把开发者自由开发的部分权限收回了，同时也限制了程序员驰骋内存、底层的梦。</p>
<p>4，最重要的一点，java程序的执行依赖于jvm（java虚拟机）为桥梁来链接java程序和操作系统，尴尬的是jvm本身就是用C来实现的。java程序的执行首先编译java程序为java class文件，然后经过jvm才能被操作系统执行，而c++编译后直接就能被操作系统执行，执行效率能不低吗！同时这个特点也是java的一个优点：跨平台行性，java class文件可以在任何支持jvm的平台上执行，windows，linux，但是c++代码经过windows编译后就无法在linux系统上面正确执行。</p>
<p>所以java的执行效率和c++是没有可比性，但是，任何事物都有双面性，执行效率低，不一定就是效率低。总体看来，java也是种很不错的语言。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 13:38:36 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>java执行效率低，但效率就低吗？的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02YjODM.html" rel="bookmark">Java执行上传的sql脚本文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开始通过java执行cmd的方式调用sqlplus执行sql文件,但是后来发现一旦进入sqlplus,脚本执行完后就会一直等待而不关闭.后为了方便改成调用ant的SQLExec类提供的实现进行sql脚本的执行.原始代码如下,我是通过前端上传sql脚本文件后台服务端进行执行:     SQLExec sqlExec = new SQLExec();     //设置数据库参数     sqlExec.setDriver(&quot;oracle.jdbc.driver.OracleDriver&quot;)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eyYQE0.html" rel="bookmark">高版本-&amp;gt&semi;低版本迁移，低版本客户端连接高版本数据库EXP导出报错EXP-00008&comma;ORA-01455&comma;EXP-00000</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				生产环境: 源数据库:RHEL + Oracle 11.2.0.3 目标数据库:HP-UX + Oracle 10.2.0.4 需求:迁移部分表  11.2.0.3--&gt;10.2.0.4,若迁移范围内的有些表在目标库已经存在,则替换. 本次迁移数据量&lt;1G. 初定方案:低版本的客户端连接到高版本数据库,用低版本导出,低版本导入. 1.采用初定方案,目标数据库所在服务器连接到源数据库,exp导出过程中报错. ZJCRNOPDB 36: sqlplus -version SQL*Plus: Rel			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmGVw13.html" rel="bookmark">Java执行SQL脚本导入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天做了一个用java导入sql脚本的功能,前台上传一个sql文件,后台先保存本地,然后进行导入.主要代码如下: String cmd = &quot;cmd /c sqlplus usr/[email protected]{//服务器IP:1521/}sid @d:\\1.sql&gt;d:\\t.log&quot;; Process p = null; try {     p = Runtime.getRuntime().exec(cmd); } catch (IOException e) {    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWyZyL3.html" rel="bookmark">【java web】java执行预编译Groovy脚本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在JVM中运行Groovy类有两种方式: 使用Groovy编译所有的*.groovy为java的*.class文件,把这些*.class文件放在java类路径中,通过java类加载器来加载这些类. 通过groovy类加载器在运行时直接加载*.groovy文件并生成对象.在这种方式下,没有生成任何*.class,但是生成了一个java.lang.Class对象的实例. 下面介绍前一种使用Groovy的方法:编译成java字节码并且作为正常java应用程序运行在java虚拟机上,即预编译模式. 1.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1jOk4.html" rel="bookmark">java执行cmd命令并获取输出结果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.java执行cmd命令并获取输出结果 1 import java.io.BufferedReader; 2 import java.io.InputStreamReader; 3 4 import org.apache.commons.lang3.text.StrBuilder; 5 6 /** 7 * 8 * @author user1 9 */ 10 public class DeleteProgram { 11 public static void run() { 12 Runtime			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OZYjX0.html" rel="bookmark">Java执行Shell脚本&OpenCurlyDoubleQuote;No such file or directory&rdquo; &NewLine;&lpar;win-&amp;gt&semi;Linux&rpar;异常的可能原因</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/zlpdaisy/article/details/6134314 用Runtime.getRuntime().exec()方法执行Linux的一个Shell脚本时,报 Cannot run program &quot;./script/abc.sh&quot;: java.io.IOException: error=2, No such file or directory] java.io.IOException: Cannot run program &q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoLlbl0.html" rel="bookmark">Java执行groovy脚本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 Binding binding = new Binding(); 2 binding.setVariable(&quot;foo&quot;, new Integer(2)); 3 GroovyShell shell = new GroovyShell(binding); 4 5 String script = &quot;import com.myb.to.infrastructure.Md5Util; &quot; 6 + &quot;def a = 12; println 'C# md5:' +			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35rJK24.html" rel="bookmark">java执行linux shell命令，并拿到返回值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 package com.suning.spc.util; 2 3 import java.io.IOException; 4 import java.io.InputStream; 5 import java.nio.charset.Charset; 6 7 import org.slf4j.Logger; 8 import org.slf4j.LoggerFactory; 9 10 import ch.ethz.ssh2.ChannelCondition; 11 import ch.eth			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JO7DnM.html" rel="bookmark">java执行cmd命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从网上找的java执行cmd命令的文章,摘抄一段. java的Runtime.getRuntime().exec(commandStr)可以调用执行cmd指令. cmd /c dir 是执行完dir命令后封闭命令窗口. cmd /k dir 是执行完dir命令后不封闭命令窗口. cmd /c start dir 会打开一个新窗口后执行dir指令,原窗口会封闭. cmd /k start dir 会打开一个新窗口后执行dir指令,原窗口不会封闭. 可以用cmd / 查看帮助信息. ★CMD命令★1			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49ZRqpM.html" rel="bookmark" class="title">发射极旁路电容作的工作原理分析与理解</a>
					<div>
						先明确一下音频范围: 音频频率范围一般可以分为四个频段:低频段(30-150Hz):中低频段(30-150Hz):中低频(150-500Hz):中高频段(500-5000Hz):高频段(5000-00 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVwwny0.html" rel="bookmark" class="title">java----八种排序算法</a>
					<div>
						1.直接插入排序 经常碰到这样一类排序问题:把新的数据插入到已经排好的数据列中. 将第一个数和第二个数排序,然后构成一个有序序列 将第三个数插入进去,构成一个新的有序序列. 对第四个数.第五个数……直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Ky2PO4.html" rel="bookmark" class="title">hdu 5381 The sum of gcd 莫队&plus;预处理</a>
					<div>
						The sum of gcd Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J8yqb0.html" rel="bookmark" class="title">cache和buffer介绍</a>
					<div>
						今天被人问及什么是cache,什么是buffer,两者之间的区别是什么,作为菜鸟的我蒙了.我只知道cache是内存的闲置空间用来缓存数据块的,以提高数据读取的速率,而buffer是缓冲区,但是具体含义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p595VM.html" rel="bookmark" class="title">java selenium &lpar;十四&rpar; 处理Iframe 中的元素</a>
					<div>
						有时候我们定位元素的时候,发现怎么都定位不了. 这时候你需要查一查你要定位的元素是否在iframe里面 阅读目录 什么是iframe iframe 就是HTML 中,用于网页嵌套网页的. 一个网页可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzDGV0.html" rel="bookmark" class="title">bzoj1789 AHOI 维护数列（线段树）</a>
					<div>
						首先想到线段树,然后刚开始写忽然想到树状数组求和岂不是更快,而且编程复杂度又小,于是把之前写的删掉,写树状数组,写完模版之后忽然发现这题竟然是区间修改! 于是又删掉重写,忽然发现不会处理又加又乘的,果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyZBp0.html" rel="bookmark" class="title">IntelliJ IDEA 设置Output 窗口字体大小</a>
					<div>
						Settings——&gt;Editor——&gt;Colors&amp;Fonts——&gt;Console Font 如图: 字体调好了以后使用起来眼睛就轻松多了					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ydJDM.html" rel="bookmark" class="title">【解决】同一url的http请求所获取的结果总是相同</a>
					<div>
						曾经在WP7写过一个通过HTTP获取网页内容的小程序,当时一直没能够解决: 有一个网址,在每次点击刷新之后页面所呈现的内容都是不同的.但是进行HTTP请求时,结果将会一直重复. 从网上查资料得知,在请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvz2e3.html" rel="bookmark" class="title">优越性</a>
					<div>
						我觉得这个好点. 1 #include&lt;cstdio&gt; 2 #include&lt;cstring&gt; 3 #include&lt;algorithm&gt; 4 #include&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azpLv3.html" rel="bookmark" class="title">韭畚讼莆烤mn5kd15v6</a>
					<div>
						http://d.1905.com/space/14098264http://sina.lt/dEtmhttp://d.1905.com/space/14118991http://t.cn/RUIL5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDlvRKM.html" rel="bookmark" class="title">kernel&lowbar;task high cpu usage</a>
					<div>
						# Find the model $ system_profiler -detailLevel mini | grep &quot;Model Identifier:&quot; Model Iden ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAm5g0.html" rel="bookmark" class="title">Alcatel OmniSwitch 重置密码</a>
					<div>
						OmniSwitch 6250重置密码 Press s to STOP AT MINIBOOT... [Miniboot]-&gt;cd &quot;network&quot; value = 0 = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J2b8P4.html" rel="bookmark" class="title">填充磁盘空间的工具和方法</a>
					<div>
						平时在测试时(比如测试安装.保存文件到本地等),可能需要构造本地硬盘空间不足的情况,这里介绍一个方法. 一.fsutil命令 1.以管理员的身份运行cmd 2.进入相应的盘符 3.命令:fsutil  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K7m9r0.html" rel="bookmark" class="title">MongoDB的查询</a>
					<div>
						MongoDB使用find来查询,不指定任何参数说明是对整个集合的文档查询. find查询 指定返回的键 有时并不需要将文档中所有键值对都返回,可以通过find(或者findOne)的第二个参数来制定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/472pao3.html" rel="bookmark" class="title">Java多线程（三）SimpleDateFormat</a>
					<div>
						多线程报错:java.lang.NumberFormatException: multiple points SimpleDateFormat是非线程安全的,在多线程情况下会有问题,在每个线程下得各自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MowmAbM.html" rel="bookmark" class="title">Tips-Windows 10【多桌面视窗】操作</a>
					<div>
						Windows 10[多桌面视窗] 当你点击任务栏上的“task view”按键时,会在屏幕中间显示你当前正在使用的桌面,你可以点击“添加桌面”来创建一个新的桌面,在这个新的桌面你可以打开其他的应用程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyDPWj4.html" rel="bookmark" class="title">用一个for循环实现打印乘法口诀表</a>
					<div>
						循环体内定义两个变量,一个控制列,一个控制行: for(int i=0,j=0;j&lt;9;i++){ System.out.println(j+&quot;*&quot;+i+&quot;=&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWeyxa3.html" rel="bookmark" class="title">Java Volatile相关文章目录</a>
					<div>
						参考资料: http://www.google.com/cse?sa.x=0&amp;sa.y=0&amp;cx=010284515138798138769%3Aajbqkpwaapm&amp;ie= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rpa57M.html" rel="bookmark" class="title">debian apache2&period;4 virtual host 使用</a>
					<div>
						篇说了debian下安装 debian apache2 和 php7 .但并没有体现apache2已经能使用php7了,这里我们和virtual host一起记录. 先进入到apache所在的目录:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MorvKB4.html" rel="bookmark" class="title">nginx的proxy&lowbar;set&lowbar;header</a>
					<div>
						nginx的变量很多其中proxy_set_header还是挺有用下面说说具体怎么用: proxy_set_header主要用在对后全请求定义header上面,向后端的真实的请求头发送请求: 例子:  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
